<template>
  <button :class="listOfClasses" v-on:click="submit" :disabled="loading">{{buttonText}}</button>
</template>
<script lang="ts">
import { Component, Vue, Watch } from "vue-property-decorator";
import * as palette from "google-palette";
import axios from "axios";

@Component
export default class SearchButton extends Vue {
  private pr_ids = new Set();
  public loading = false;
  get enterDown() {
    return this.$store.getters.enterDown;
  }
  get curso() {
    return this.$store.getters.curso;
  }
  get disciplina() {
    return this.$store.getters.disciplina;
  }
  get profundidade() {
    return this.$store.getters.profundidade;
  }
  get listOfClasses() {
    if (!this.loading) {
      return [
        "bg-padrao",
        "text-white",
        "font-sans",
        "py-2",
        "px-8",
        "my-1",
        "min-w-10",
        "rounded-full w-2/3",
        "hover:bg-blue-700",
        "lg:w-2/12",
        "md:w-2/12",
      ];
    }
    return [
      "bg-yellow-600",
      "text-grey-800",
      "font-sans",
      "py-2",
      "px-8",
      "my-1",
      "rounded-full w-2/3",
      "bg-white",
      "lg:w-2/12",
      "md:w-2/12",
    ];
  }
  get buttonText() {
    if (this.loading) return "Carregando...";
    return "Pesquisar";
  }

  @Watch("enterDown", { immediate: true })
  public enter(newValue: boolean) {
    if (newValue) {
      this.$store.dispatch("resetEnterDown");
      this.submit();
    }
  }

  async submit() {
    const cleanCurso = this.curso.replace(/ /g, "-");
    const cleanDisciplina = this.disciplina.replace(/ /g, "-");

    this.loading = true;
    const { data } = await axios.get(
      `https://uspreq-api.herokuapp.com/neo4j/requisitos?curso=${cleanCurso}&termo=${cleanDisciplina}&profundidade=${this.profundidade}`
    );
    this.loading = false;

    const grafo: any = {};

    data.results.centers.forEach((element: any) => {
      data.results.nodes.find((element2: any) => {
        return element2.code == element.code;
      }).class = ["init"];
    });
    const newLinks = data.results.links.map((link: any) => {
      const { source, target } = link;
      return { ...link, source: target, target: source };
    });

    grafo.nodes = Array.from(data.results.nodes);
    grafo.links = Array.from(newLinks);

    this.$store.dispatch("alteraGrafo", grafo);
  }
}
</script>
